/**
 * Copyright (c) Meta Platforms, Inc. and affiliates.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */
var e=require("prismjs/components/prism-core");require("prismjs/components/prism-clike");require("prismjs/components/prism-javascript");require("prismjs/components/prism-markup");require("prismjs/components/prism-markdown");require("prismjs/components/prism-c");require("prismjs/components/prism-css");require("prismjs/components/prism-objectivec");require("prismjs/components/prism-sql");require("prismjs/components/prism-python");require("prismjs/components/prism-rust");require("prismjs/components/prism-swift");
var l=require("@lexical/utils"),t=require("lexical");
class u extends t.TextNode{constructor(a,b,c){super(a,c);this.__highlightType=b}static getType(){return"code-highlight"}static clone(a){return new u(a.__text,a.__highlightType||void 0,a.__key)}createDOM(a){const b=super.createDOM(a);a=v(a.theme,this.__highlightType);l.addClassNamesToElement(b,a);return b}updateDOM(a,b,c){const d=super.updateDOM(a,b,c);a=v(c.theme,a.__highlightType);c=v(c.theme,this.__highlightType);a!==c&&(a&&l.removeClassNamesFromElement(b,a),c&&l.addClassNamesToElement(b,c));return d}setFormat(){return this.getWritable()}}
function v(a,b){return b&&a&&a.codeHighlight&&a.codeHighlight[b]}function x(a,b){return new u(a,b)}function y(a){return a instanceof u}
class z extends t.ElementNode{static getType(){return"code"}static clone(a){return new z(a.__language,a.__key)}constructor(a,b){super(b);this.__language=a}createDOM(a){const b=document.createElement("code");l.addClassNamesToElement(b,a.theme.code);b.setAttribute("spellcheck","false");return b}updateDOM(){return!1}static convertDOM(){return{div:()=>({conversion:A,priority:1}),pre:()=>({conversion:B,priority:0}),table:a=>C(a)?{conversion:D,priority:4}:null,td:a=>{const b=a.closest("table");return a.classList.contains("js-file-line")?
{conversion:E,priority:4}:b&&C(b)?{conversion:F,priority:4}:null},tr:a=>(a=a.closest("table"))&&C(a)?{conversion:F,priority:4}:null}}insertNewAfter(a){var b=this.getChildren(),c=b.length;if(2<=c&&"\n"===b[c-1].getTextContent()&&"\n"===b[c-2].getTextContent()&&a.isCollapsed()&&a.anchor.key===this.__key&&a.anchor.offset===c)return b[c-1].remove(),b[c-2].remove(),a=t.$createParagraphNode(),this.insertAfter(a),a;b=a.anchor.getNode();var d=G(b);if(null!=d){c=0;for(d=d.getTextContent();c<d.length&&/[\t ]/.test(d[c]);)c+=
1;if(0<c)return c=d.substring(0,c),c=x(c),b.insertAfter(c),a.insertNodes([t.$createLineBreakNode()]),c.select(),c}return null}canInsertTab(){return!0}collapseAtStart(){const a=t.$createParagraphNode();this.getChildren().forEach(b=>a.append(b));this.replace(a);return!0}setLanguage(a){this.getWritable().__language=a}getLanguage(){return this.getLatest().__language}}function H(a){return new z(a)}function I(a){return a instanceof z}
function G(a){let b=null;const c=a.getPreviousSiblings();for(c.push(a);0<c.length&&(a=c.pop(),y(a)&&(b=a),!t.$isLineBreakNode(a)););return b}function J(a){let b=null;const c=a.getNextSiblings();for(c.unshift(a);0<c.length&&(a=c.shift(),y(a)&&(b=a),!t.$isLineBreakNode(a)););return b}function B(){return{node:H()}}function A(a){return{after:b=>{const c=a.parentNode;null!=c&&a!==c.lastChild&&b.push(t.$createLineBreakNode());return b},node:null!==a.style.fontFamily.match("monospace")?H():null}}
function D(){return{node:H()}}function F(){return{node:null}}function E(a){return{after:b=>{a.parentNode&&a.parentNode.nextSibling&&b.push(t.$createLineBreakNode());return b},node:null}}function C(a){return a.classList.contains("js-file-line-container")}function K(a,b){const c=a.getParent();I(c)?L(c,b):y(a)&&a.replace(t.$createTextNode(a.__text))}let M=!1;
function L(a,b){M||(M=!0,b.update(()=>{void 0===a.getLanguage()&&a.setLanguage("javascript");N(a,()=>{var c=a.getTextContent();c=e.tokenize(c,e.languages[a.getLanguage()||""]||e.languages.javascript);c=P(c);var d=a.getChildren();let f=0;for(;f<d.length&&Q(d[f],c[f]);)f++;var k=d.length;const m=c.length,p=Math.min(k,m)-f;let h=0;for(;h<p;)if(h++,!Q(d[k-h],c[m-h])){h--;break}d=f;k-=h;c=c.slice(f,m-h);const {from:g,to:n,nodesForReplacement:r}={from:d,nodesForReplacement:c,to:k};return g!==n||r.length?
(a.splice(g,n-g,r),!0):!1})},{onUpdate:()=>{M=!1},skipTransforms:!0}))}function P(a){const b=[];a.forEach(c=>{if("string"===typeof c){c=c.split("\n");for(var d=0;d<c.length;d++){const f=c[d];f.length&&b.push(x(f));d<c.length-1&&b.push(t.$createLineBreakNode())}}else({content:d}=c),"string"===typeof d?b.push(x(d,c.type)):1===d.length&&"string"===typeof d[0]?b.push(x(d[0],c.type)):b.push(...P(d))});return b}
function N(a,b){var c=t.$getSelection();if(t.$isRangeSelection(c)&&c.anchor){c=c.anchor;var d=c.offset,f="element"===c.type&&t.$isLineBreakNode(a.getChildAtIndex(c.offset-1)),k=0;if(!f){const m=c.getNode();k=d+m.getPreviousSiblings().reduce((p,h)=>p+(t.$isLineBreakNode(h)?0:h.getTextContentSize()),0)}b()&&(f?c.getNode().select(d,d):a.getChildren().some(m=>{if(t.$isTextNode(m)){const p=m.getTextContentSize();if(p>=k)return m.select(k,k),!0;k-=p}return!1}))}}
function Q(a,b){return y(a)&&y(b)?a.__text===b.__text&&a.__highlightType===b.__highlightType:t.$isLineBreakNode(a)&&t.$isLineBreakNode(b)?!0:!1}function R(a){var b=t.$getSelection();if(!t.$isRangeSelection(b)||b.isCollapsed())return!1;b=b.getNodes();for(var c=0;c<b.length;c++){var d=b[c];if(!y(d)&&!t.$isLineBreakNode(d))return!1}c=G(b[0]);null!=c&&S(c,a);for(c=1;c<b.length;c++)d=b[c],t.$isLineBreakNode(b[c-1])&&y(d)&&S(d,a);return!0}
function S(a,b){const c=a.getTextContent();b===t.INDENT_CONTENT_COMMAND?0<c.length&&/\s/.test(c[0])?a.setTextContent("\t"+c):(b=x("\t"),a.insertBefore(b)):0===c.indexOf("\t")&&(1===c.length?a.remove():a.setTextContent(c.substring(1)))}
function T(a,b){const c=t.$getSelection();if(!b.altKey||!t.$isRangeSelection(c))return!1;const {anchor:d,focus:f}=c,k=d.offset,m=f.offset,p=d.getNode(),h=f.getNode();if(!y(p)||!y(h))return!1;var g=G(p),n=J(h);if(null==g||null==n)return!1;const r=g.getNodesBetween(n);for(let q=0;q<r.length;q++){const O=r[q];if(!y(O)&&!t.$isLineBreakNode(O))return!1}b.preventDefault();b.stopPropagation();g=(b=a===t.KEY_ARROW_UP_COMMAND)?g.getPreviousSibling():n.getNextSibling();if(!t.$isLineBreakNode(g))return!0;n=
b?g.getPreviousSibling():g.getNextSibling();if(null==n)return!0;b=b?G(n):J(n);let w=null!=b?b:n;g.remove();r.forEach(q=>q.remove());a===t.KEY_ARROW_UP_COMMAND?(r.forEach(q=>w.insertBefore(q)),w.insertBefore(g)):(w.insertAfter(g),w=g,r.forEach(q=>{w.insertAfter(q);w=q}));c.setTextNodeRange(p,k,h,m);return!0}exports.$createCodeHighlightNode=x;exports.$createCodeNode=H;exports.$isCodeHighlightNode=y;exports.$isCodeNode=I;exports.CodeHighlightNode=u;exports.CodeNode=z;
exports.getCodeLanguages=()=>Object.keys(e.languages).filter(a=>"function"!==typeof e.languages[a]).sort();exports.getDefaultCodeLanguage=()=>"javascript";exports.getFirstCodeHighlightNodeOfLine=G;exports.getLastCodeHighlightNodeOfLine=J;
exports.registerCodeHighlighting=function(a){if(!a.hasNodes([z,u]))throw Error("CodeHighlightPlugin: CodeNode or CodeHighlightNode not registered on editor");return l.mergeRegister(a.registerNodeTransform(z,b=>L(b,a)),a.registerNodeTransform(t.TextNode,b=>K(b,a)),a.registerNodeTransform(u,b=>K(b,a)),a.registerCommand(t.INDENT_CONTENT_COMMAND,()=>R(t.INDENT_CONTENT_COMMAND),1),a.registerCommand(t.OUTDENT_CONTENT_COMMAND,()=>R(t.OUTDENT_CONTENT_COMMAND),1),a.registerCommand(t.KEY_ARROW_UP_COMMAND,b=>
T(t.KEY_ARROW_UP_COMMAND,b),1),a.registerCommand(t.KEY_ARROW_DOWN_COMMAND,b=>T(t.KEY_ARROW_DOWN_COMMAND,b),1))};
